package com.totopia.server;

import com.google.gson.ExclusionStrategy;
import com.google.gson.FieldAttributes;
import com.totopia.server.commons.base.gson.annotation.Exclude;

import org.springframework.boot.autoconfigure.gson.GsonBuilderCustomizer;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
public class ApplicationGsonExclusionStrategy {

  @Bean
  GsonBuilderCustomizer gsonBuilderCustomizer() {
    return (gsonBuilder) -> gsonBuilder.addSerializationExclusionStrategy(new ExclusionStrategy() {

      @Override
      public boolean shouldSkipField(FieldAttributes f) {
        return f.getAnnotation(Exclude.class) != null;
      }

      @Override
      public boolean shouldSkipClass(Class<?> clazz) {
        return false;
      }

    });
  }
}
