package com.totopia.server.user.model;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.*;

import com.totopia.server.commons.base.gson.annotation.Exclude;

import com.totopia.server.commons.base.model.Base;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.annotations.CreationTimestamp;
import org.hibernate.annotations.UpdateTimestamp;

@Entity
@Table(name = "TBL_USER")
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@AttributeOverrides({
        @AttributeOverride(name = "createDate", column = @Column(name = "registDate")),
        @AttributeOverride(name = "updateDate", column = @Column(name = "lastvisitDate")),
})
public class User extends Base implements Serializable {
  private static final long serialVersionUID = 2783105197387637187L;

//  @Id
//  @GeneratedValue(generator = "user_generator")
//  @SequenceGenerator(name = "user_generator", sequenceName = "user_sequence", initialValue = 1000)
//  private Long id;

  @Basic
  @Column(name = "username", unique = true, nullable = false, length = 150)
  private String username;

  @Basic
  @Column(name = "password", nullable = false, length = 100)
  @Exclude
  private String password;

  @Transient
  private String passwordConfirm;

  @Basic
  @Column(name = "name", nullable = false, length = 255)
  private String nickname;

  @Basic
  @Column(name = "email", nullable = false, length = 100)
  private String email;

  @Basic
  @Column(name = "block", nullable = false, columnDefinition = "bool default false")
  private Boolean block;

  @Basic
  @Column(name = "is_admin", nullable = false, columnDefinition = "bool default false")
  private Boolean isAdmin;

  @Basic
  @Column(name = "send_email", nullable = true, columnDefinition = "bool default false")
  private Boolean sendEmail;

//  @AttributeOverride(name = "createDate", column = @Column(name = "regist_date"))
//  private Date registerDate;
//
//  @AttributeOverride(name = "updateDate", column = @Column(name = "lastvisit_date"))
//  private Date lastvisitDate;
//  @Basic
//  @CreationTimestamp
//  @Temporal(TemporalType.TIMESTAMP)
//  @Column(name = "register_date", nullable = false)
//  private Date registerDate;
//
//  @Basic
//  @Temporal(TemporalType.TIMESTAMP)
//  @Column(name = "lastvisit_date", nullable = false)
//  private Date lastvisitDate;

  @Basic
  @Column(name = "activation", nullable = false, length = 100)
  private String activation;

  @Basic
  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "last_reset_time", nullable = false)
  private Date lastResetTime;

  @Basic
  @Column(name = "reset_count", nullable = false)
  private Long resetCount;

  @Basic
  @Column(name = "otp_key", nullable = false, length = 1000)
  private String otpKey;

  @Basic
  @Column(name = "otep", nullable = false, length = 1000)
  private String otep;

  @Basic
  @Column(name = "require_reset", nullable = true, columnDefinition = "bool default false")
  private Boolean requireReset;

}

// 아이디
// 로그인 아이디
// 로그인 패스워드
// 로그인 패스워드 문자
// 이메일
// 닉네임
// 은행명
// 계좌번호
// 예금주
// 추천인
// 추천수
// 게시판 제한 여부
// 쿠폰
// 충전방식
// 비고
// 종목별 베팅제한
// 상태표기
// 휴대폰번호
// 추천권한 여부
// 가입상태
// 소속
// 레벨
// 보유머니
// 포인트
// 회원상태
// 룰렛개수
// 계좌순번
// 가입날짜
// 최근접속 날짜
// 가입 아이피
// 최근 접속 아이피
// 베팅 알림
// API 연결
