package com.totopia.server.user.repository;

import com.totopia.server.user.model.BankAccount;
import com.totopia.server.user.model.User;
import org.junit.Before;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import static org.junit.Assert.*;

@Ignore
@RunWith(SpringRunner.class)
@SpringBootTest
public class BankAccountRepositoryTest {

    @Autowired
    private UserRepository userRepository;

    @Autowired
    private BankAccountRepository bankAccountRepository;

    List<User> users;
    List<BankAccount> accounts = new ArrayList<>();

    @Before
    public void setUp() throws Exception {
        users = this.userRepository.findAll();

        if(users == null) {
            throw new Exception("user list Null");
        }
    }

    @Test
    public void testInsert() {

        BankAccount bankAccount = null;

        int idx = 0;
        for (User user : users) {
            bankAccount = new BankAccount();

            switch (idx) {
                case 0:
                    bankAccount.setName("국민은행");
                    bankAccount.setHolder("예금주1");
                    bankAccount.setNumber("123-422-23112");
                    break;
                case 1:
                    bankAccount.setName("우리은행");
                    bankAccount.setHolder("예금주2");
                    bankAccount.setNumber("321-555-3312-21");
                    break;
                case 2:
                    bankAccount.setName("기업은행");
                    bankAccount.setHolder("예금주3");
                    bankAccount.setNumber("832-2392-2392-29829");
                    break;
            }
            idx++;
            bankAccount.setUserId(user.getId());
            bankAccount.setUpdateDate(new Date());
            this.bankAccountRepository.save(bankAccount);
        }
    }

    @Test
    public void testUpdate() {
        List<BankAccount> bankAccounts = this.bankAccountRepository.findAll();

        int idx = 0;
        for (BankAccount account : bankAccounts) {

            switch (idx) {
                case 0:
                    account.setName("국민은행");
                    account.setHolder("예금주1");
                    account.setNumber("123-422-23112");
                    break;
                case 1:
                    account.setName("우리은행");
                    account.setHolder("예금주2");
                    account.setNumber("321-555-3312-21");
                    break;
                case 2:
                    account.setName("기업은행");
                    account.setHolder("예금주3");
                    account.setNumber("832-2392-2392-29829");
                    break;
            }
            idx++;
            account.setUserId(account.getUserId());

            this.bankAccountRepository.save(account);
        }
    }
}