package com.totopia.server.user.repository;

import com.totopia.server.user.model.User;
import org.junit.Before;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import static org.junit.Assert.*;


@Ignore
@RunWith(SpringRunner.class)
@SpringBootTest
public class UserRepositoryTest {

    @Autowired
    private UserRepository userRepository;

//    private User.UserBuilder user;

    private List<User> userList = new ArrayList<>();

    @Before
    public void setUp() throws Exception {
        User.UserBuilder user = User.builder()
                .activation("Y")
                .block(false)
                .email("geekdev@naver.com")
                .isAdmin(true)
                .nickname("admin")
                .otep("")
                .otpKey("")
                .password("qwer5795")
                .username("admin")
                .requireReset(false)
                .resetCount(Long.valueOf(0))
                .lastResetTime(new Date());

        User temp = user.build();
        temp.setUpdateDate(new Date());
        userList.add(temp);

        user = User.builder()
                .activation("Y")
                .block(false)
                .email("geektest1@naver.com")
                .isAdmin(false)
                .nickname("test1")
                .otep("")
                .otpKey("")
                .password("qwer5795")
                .username("test1")
                .requireReset(false)
                .resetCount(Long.valueOf(0))
                .lastResetTime(new Date());

        temp = user.build();
        temp.setUpdateDate(new Date());
        userList.add(temp);

        user = User.builder()
                .activation("Y")
                .block(false)
                .email("geektest2@naver.com")
                .isAdmin(false)
                .nickname("test2")
                .otep("")
                .otpKey("")
                .password("qwer5795")
                .username("test2")
                .requireReset(false)
                .resetCount(Long.valueOf(0))
                .lastResetTime(new Date());

        temp = user.build();
        temp.setUpdateDate(new Date());
        userList.add(temp);
    }

    @Test
    public void findByUsername() {
        User admin = this.getAdmin();
        if (admin == null) {
            this.userRepository.saveAll(userList);
            assertEquals("Equlas", userList.get(0).getNickname(), "admin");
        }
    }

    @Test
    public void findByEmail() {
        User admin = this.getAdmin();

        if(admin != null) {

        }
    }

    @Test
    public void findAllByNickname() {
    }

    @Test
    public void findAllByBlockTrue() {
    }

    @Test
    public void findAllByBlockFalse() {
    }

    @Test
    public void findAllByIsAdminTrue() {
    }

    @Test
    public void findAllByRequireResetTrue() {
    }

    @Test
    public void findAllByIsAdminFalseAndActivationEquals() {
    }

    @Test
    public void findAllByRegisterDateBetween() {
    }

    @Test
    public void findAllByLastvisitDateBetween() {
    }

    @Test
    public void findAllByLastResetTimeBetween() {
    }

    @Test
    public void countByRegisterDateGreaterThanEqual() {
    }

    private User getAdmin()  {
        try {
            return this.userRepository.findByUsername("admin");
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }
}